const express = require('express');
const proxy = require('express-http-proxy');
const app = express();
app.use(express.json({limit: '200mb'}));
const PORT = 3000;

const HOST = process.env.HOST
const SOCKS_URL = process.env.SOCKS_URL

let activeProxy = proxy(HOST, {
  proxyTimeout: 30000, 
  timeout: 30000,
  proxyReqOptDecorator: function(proxyReqOpts, srcReq) {
    proxyReqOpts.headers['Host'] = new URL(HOST).host;
    const { SocksProxyAgent } = require('socks-proxy-agent');
    const socksAgent = new SocksProxyAgent(SOCKS_URL);
    proxyReqOpts.agent = socksAgent;
    return proxyReqOpts;
  },
  proxyReqBodyDecorator: function(bodyContent, srcReq) {
    return JSON.stringify(srcReq.body);
  }
});


app.use('/', activeProxy);

app.listen(PORT, () => {
    console.log(`proxy on http://127.0.0.1:${PORT}`);
});